<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.*" %>
<%@ page import="org.apache.commons.lang.StringEscapeUtils" %> 
<%@ page import="com.invoqsystems.integration.remedy.scriptobjects.*" %>
<%@ page import="com.invoqsystems.integration.remedy.scriptobjects.wsutils.*" %>


<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />

<jsp:useBean id="serviceDeskBean"
             class="com.invoqsystems.integration.remedy.scriptobjects.ServiceDeskScriptObject"
             scope="session" />

<%
  /**
   * You can change these following variables to match the correct information, if necessary.
   */
  final int MAX_DISPLAY_CHARACTERS = 60;
  final int MAX_RECIPIENT_DISPLAY_CHARACTERS = 80;
  final boolean QUERY_PREDICATE_VALUES = true;
  
  final String SUPPORT_COMPANY_ID_PREDICATE_NAME = "SUPPORT_COMPANY";
  final String SUPPORT_ORGANIZATION_PREDICATE_NAME = "SUPPORT_ORGANIZATION";
  final String SUPPORT_GROUP_PREDICATE_NAME = "SUPPORT_GROUP";
  final String CHANGE_TYPE_PREDICATE_NAME = "CHANGE_TYPE";
  final String STATUS_PREDICATE_NAME = "STATUS";
  final String IMPACT_PREDICATE_NAME = "IMPACT";
  final String URGENCY_PREDICATE_NAME = "URGENCY";
  final String PRIORITY_PREDICATE_NAME = "PRIORITY";
  
  final String REMEDY_URL = "http://localhost:80";
  final String REMEDY_NAME = "LOCALHOST";
  final String REMEDY_USER = "Demo";
  final String REMEDY_PASSWORD = "";
  
  if(QUERY_PREDICATE_VALUES)
  {
    serviceDeskBean.initClient( REMEDY_URL, REMEDY_NAME, REMEDY_USER, REMEDY_PASSWORD, null, null, null );
  }
%>


<subscription-panel xmlns:fi="http://apache.org/cocoon/forms/1.0#instance"
                    xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
                    onload="onLoad();"
                    onsubmit="return validateForm(this);" >

<%
  // set up the map for storing the selected values for each predicate
  final HashMap<String, ArrayList<String>> selectedPredicateValuesMap = new HashMap<String, ArrayList<String>>();
  final HashMap<String, PredicateBean> predicateNameMap = new HashMap<String, PredicateBean>();
  final HashMap<String, String> predicateSummaryNamesMap = new HashMap<String, String>();

  final StringBuffer summaryName = new StringBuffer();
  // collect the selected predicate values, and pre-populated values
  Iterator<PredicateBeanImpl> iterator = subscriptionBean.getPredicateIterator();
  while(iterator.hasNext())
  {
     final PredicateBean predicate = iterator.next();
     ArrayList<String> selectedValues = new ArrayList<String>();
     selectedValues.addAll(predicate.getSelectedValues());

     selectedPredicateValuesMap.put(predicate.getPredicateName(), selectedValues);
     predicateNameMap.put(predicate.getPredicateName(), predicate);

     if(!predicate.getSelectedValues().isEmpty())
     {
       summaryName.delete(0, summaryName.length());
       if(predicate.hasAnySelectedValue())
       {
         summaryName.append("ANY");
       }
       else
       {
         Iterator<String> valIter = predicate.getSelectedValues().iterator();
         while(valIter.hasNext())
         {
           summaryName.append(valIter.next());
           if(valIter.hasNext())
             summaryName.append(", ");
           if(summaryName.length() > MAX_DISPLAY_CHARACTERS)
           {
             summaryName.setLength(MAX_DISPLAY_CHARACTERS);
             break;
           }
         }
       }
       predicateSummaryNamesMap.put(predicate.getPredicateName(), StringEscapeUtils.escapeXml(summaryName.toString()));
    }
  }

  final String subId = (String)request.getParameter("subscriptionId");
  final boolean creatingSubscription = subId == null || "0".equals(subId);

  /**
   * This tab count will contain the total number tabs that will be displayed.
   */
  // The total number of tabs that will be displayed
  int tabCount = 5;
  if(creatingSubscription)
  {
    tabCount--;
  }
  if(subscriptionBean.isSelfSubscription())
  {
    tabCount--;
  }
  if(subscriptionBean.allOverridesSuppressed() && subscriptionBean.isTimeframeSuppressed())
  {
    tabCount--;
  }

  /**
   * This maps the tab position for each predicate.
   */
  final HashMap<String, String> predicateTabPositionMap = new HashMap<String, String>();
  predicateTabPositionMap.put(SUPPORT_COMPANY_ID_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(SUPPORT_ORGANIZATION_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(SUPPORT_GROUP_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(CHANGE_TYPE_PREDICATE_NAME, "2");
  predicateTabPositionMap.put(STATUS_PREDICATE_NAME, "2");
  predicateTabPositionMap.put(IMPACT_PREDICATE_NAME, "2");
  predicateTabPositionMap.put(URGENCY_PREDICATE_NAME, "2");
  predicateTabPositionMap.put(PRIORITY_PREDICATE_NAME, "2");
  
  final HashMap<String, String> predicateLabelMap = new HashMap<String, String>();
  predicateLabelMap.put(SUPPORT_COMPANY_ID_PREDICATE_NAME, "Support Company ID");
  predicateLabelMap.put(SUPPORT_ORGANIZATION_PREDICATE_NAME, "Support Organization");
  predicateLabelMap.put(SUPPORT_GROUP_PREDICATE_NAME, "Support Group");
  predicateLabelMap.put(CHANGE_TYPE_PREDICATE_NAME, "Change Type");
  predicateLabelMap.put(STATUS_PREDICATE_NAME, "Status");
  predicateLabelMap.put(IMPACT_PREDICATE_NAME, "Impact");
  predicateLabelMap.put(URGENCY_PREDICATE_NAME, "Urgency");
  predicateLabelMap.put(PRIORITY_PREDICATE_NAME, "Priority");
  
  final List<String> assignmentPredicates = Arrays.asList( SUPPORT_COMPANY_ID_PREDICATE_NAME, SUPPORT_ORGANIZATION_PREDICATE_NAME, SUPPORT_GROUP_PREDICATE_NAME );
  final List<String> changeInfoPredicates = Arrays.asList( CHANGE_TYPE_PREDICATE_NAME, STATUS_PREDICATE_NAME, IMPACT_PREDICATE_NAME, URGENCY_PREDICATE_NAME, PRIORITY_PREDICATE_NAME );
%>

<style media="screen" type="text/css">
  span.forms-tab {      
    display: inline;
    position: relative;
    top: -1px;
    z-index: 1;
    overflow: hidden;
    font-weight: bold;    
        text-decoration: none;
        cursor: pointer;
    color: #333;    
        background: transparent url(/static/images/layout/main-menu-bg-off.gif) no-repeat top left;
        padding: 6px 7px 1px 11px;
        border-right: 1px solid #666;
    border-bottom: 1px solid #666;
    border-top: none;
    border-left: none;    
    margin: 0;
  }

  span.forms-tab:hover {        
    background: transparent url(/static/images/layout/main-menu-bg-hover.gif) no-repeat top left;
  }

  span.forms-tab.forms-activeTab {
        display: inline;
    position: relative;
    top: 1px;
    z-index: 10;    
    overflow: hidden; 
        cursor: default;
    color: #990033;
    background: transparent url(/static/images/layout/main-menu-bg-selected.gif) no-repeat top left;
    padding: 7px 7px 1px 11px;
    border-bottom: none;
  }

  span.forms-tab.forms-activeTab:hover {
        background-color: #FFF;
        position: relative;
  }

  span.forms-tabContent {
        background-color: #FFF;
        border: 1px solid #666;
        /*padding: 3em;*/
        position: relative;
        z-index: 2;
  }

  #sandbag-01,
  #sandbag-02 {
        clear: left;
        float: left;
        padding: 0pt; /*border: 1px solid #0f0;*/
  }

  #sandbag-01 {
        height: 10px;
        width: 160px;
  }

  #sandbag-02 {
        height: 10px;
        width: 95px;
  }

  label#matching {
        font-weight: bold;
    width: 175px;
  }

  div.form-row label.summary {
        font-weight: bold;
        width: 0px;
        float: none;
        text-align: left;
        vertical-align: middle;
        padding: 0px 4px 0px 0px;
        margin-left: 85px;
  }

  span.summary-row {
        float: none;
        text-align: left;
        vertical-align: middle;
        padding: 0px 0px 0px 0px;
  }

  span.summary-row span.summary-item {
        float: none;
        padding: 0px 5px 0px 0px;
  }

  span.elipse {
        font-size: 11px;
        color: #0000CC;
        margin: 0px 0px 0px 5px;
        padding: 0;
        text-decoration: underline;
        background-color: transparent;
        border: none;
        cursor: pointer;
  }

  div.form-row ul#summary_list {
        margin-left: 100px;
        padding: 0px 0px 0px 0px;
  }

  div.form-row ul#summary_list li {
        display: list-item;
        padding: 0px 3px 0px 0px;
  }

  div.form-row ul#summary_list li.summary_AND {
        font-weight: bold;
        list-style: none;
        margin-left: 20px;
  }

  div.form-row ul#summary_list li.summary-item span.summary_text italic {
        font-style: italic;
  }
</style>

<script type="text/javascript" language="JavaScript">
  var old_forms_showTab;
  function onLoad()
  {
   old_forms_showTab = forms_showTab;
   forms_showTab = new_forms_showTab;
   var lastTab = document.DefaultSubscriptionForm.currentTab.value;
   if(window.location.hash == "#recipients")
     lastTab = 4;
   if(lastTab != null &amp;&amp; lastTab != "" &amp;&amp; lastTab != "null")
     forms_showTab("attributes", lastTab, 5, "");
  }
  
  function new_forms_showTab(tabgroup, idx, length, state)
  {
    document.DefaultSubscriptionForm.currentTab.value = idx;
    old_forms_showTab(tabgroup, idx, length, state);
  }
</script>

<input type="hidden" name="currentTab" value="<%=request.getParameter("currentTab")%>" /> 

<text-widget id="name">
  <value><%= subscriptionBean.getName() %></value>
</text-widget>

<group label="Attributes">

<tab-group id="attributes">

<%
  if(!creatingSubscription)
  {
%>
    <tab-content id="summary_tab" label="Summary">
      <div class="form-row">
        <label id="matching">Matching Any Event Where</label>
      </div>
      <div class="form-row">
        <ul id="summary_list">
<%
  iterator = subscriptionBean.getPredicateIterator();
  boolean firstNonEmptyPredicate = true;
  while(iterator.hasNext())
  {
     final PredicateBean predicate = iterator.next();
     if(!predicate.getSelectedValues().isEmpty())
     {
       String summary = predicateSummaryNamesMap.get(predicate.getPredicateName());
       String predPosition = predicateTabPositionMap.get(predicate.getPredicateName());
%>
  <% if(!firstNonEmptyPredicate) { %>
          <li class="summary_AND">
            <span class="summary_text">AND</span>
          </li>
  <% }%>

          <li class="summary-item">
            <span class="predicate_data"><%=predicateLabelMap.get(predicate.getPredicateName())%></span>
            <span class="summary_text italic"> <%=predicate.getSelectedOperatorType()%></span>
            <span class="predicate_data"> (<%=summary%></span>
            <% if(summary.length() == MAX_DISPLAY_CHARACTERS) { %>
            <span class="elipse" onclick="forms_showTab('attributes', <%=predPosition%>, <%=Integer.toString(tabCount)%>, '')" >...</span>
            <% } %>
            <span class="summary_text">)</span>
          </li>
<%
           firstNonEmptyPredicate = false;
     }
  }
%>
        </ul>
        </div>

        <div class="form-row">
          <label class="summary">Available:</label>
         <span class="summary-row">
<%
          if(subscriptionBean.isOnSunday())
          {
            out.print("<span class=\"summary-item\">Sun</span>");
          }
          if(subscriptionBean.isOnMonday())
          {
            out.print("<span class=\"summary-item\">Mon</span>");
          }
          if(subscriptionBean.isOnTuesday())
          {
            out.print("<span class=\"summary-item\">Tue</span>");
          }
          if(subscriptionBean.isOnWednesday())
          {
            out.print("<span class=\"summary-item\">Wed</span>");
          }
          if(subscriptionBean.isOnThursday())
          {
            out.print("<span class=\"summary-item\">Thu</span>");
          }
          if(subscriptionBean.isOnFriday())
          {
            out.print("<span class=\"summary-item\">Fri</span>");
          }
          if(subscriptionBean.isOnSaturday())
          {
            out.print("<span class=\"summary-item\">Sat</span>");
          }
%>

          <span class="summary-item"><%=subscriptionBean.getStartTime()%></span>
          <span class="summary-item">-</span>
          <span class="summary-item"><%=subscriptionBean.getEndTime()%></span>
        </span>
        </div>
        <div class="form-row">
          <label class="summary">Using:</label>
          <span class="summary-row">
<%
          if(subscriptionBean.hasAllDeviceFilter())
          {
            out.print("<span class=\"summary-item\">All Devices</span>");
          }
          else
          {
            ArrayList<String> types = subscriptionBean.getDeviceTypeOverrides();
            for(String type : types)
            {
%>
            <span class="summary-item"><%=type.substring(NotificationAPI.DEVICE_FILTER_FIELD_PREFIX.length())%></span>
<%
            }
          }
%>
          </span>
        </div>
<%
  if(!subscriptionBean.isSelfSubscription())
  {
%>
        <div class="form-row">
          <label class="summary">Targeting:</label>
          <span class="summary-row">
<%
         int charactersDisplayed = 0;
         ArrayList<String> recipients = subscriptionBean.getRecipients();
         for(String recipient : recipients)
         {
%>
          <span class="summary-item"><%=recipient%></span>
<%
           charactersDisplayed += recipient.length();
           if(charactersDisplayed > MAX_RECIPIENT_DISPLAY_CHARACTERS)
           {
             out.print("<span class=\"summary-item\">...</span>");
             break;
           }
         }
%>
          </span>
        </div>
<%
  }
%>
    </tab-content>

<%
  }
%>

    <tab-content id="support_info_tab" label="Change Manager Support Information">

<%
    for(String predicateName : assignmentPredicates){
      PredicateBean predicate = predicateNameMap.get(predicateName);
      ArrayList<String> selectedValues = selectedPredicateValuesMap.get(predicateName);
%>
      <div class="form-row">
        <label class="widget" for="<%=predicate.getPredicateValueWidgetId()%>"><%=predicateLabelMap.get(predicateName)%>:</label>
        <span  id="<%=predicate.getPredicateValueWidgetId()%>">
          <select size="3" multiple="0" id="<%=predicate.getPredicateValueWidgetId()%>" name="<%=predicate.getPredicateValueWidgetId()%>" >
            <option value="<%=subscriptionBean.getAnyPredicateListValue() %>" <% if(selectedValues.contains(subscriptionBean.getAnyPredicateListValue()))out.print("selected=\"true\""); %> >-- ANY --</option>
<%
			String operation = "APCM_Query_Support";
			String service = "APCM_CTM_Support_Information_WS";
            String valuesNode = "getListValues";
			List<GenericWSScriptObject> wsObjs = serviceDeskBean.queryScriptObjectList(operation, service, valuesNode, null, null, null);
						
			String fieldName;
			String value;
			Collection<String> values = new ArrayList<String>();
			if(QUERY_PREDICATE_VALUES && predicateName.equals(SUPPORT_COMPANY_ID_PREDICATE_NAME)) {
			  fieldName = "Company";
			  for(GenericWSScriptObject obj : wsObjs) {
			    value = (String)obj.get(fieldName);
				if ( !values.contains(value) ) {
				  values.add(value);
				}
			  }
			}else if(QUERY_PREDICATE_VALUES && predicateName.equals(SUPPORT_ORGANIZATION_PREDICATE_NAME)) {
			  fieldName = "Support_Organization";
			  for(GenericWSScriptObject obj : wsObjs) {
				value = (String)obj.get(fieldName);
				if ( !values.contains(value) ) {
				  values.add(value);
				}
			  }
			}else if(QUERY_PREDICATE_VALUES && predicateName.equals(SUPPORT_GROUP_PREDICATE_NAME)) {
			  fieldName = "Support_Group_Name";
			  for(GenericWSScriptObject obj : wsObjs) {
			    value = (String)obj.get(fieldName);
				if ( !values.contains(value) ) {
				  values.add(value);
				}
			  }
            }else{
              values = predicate.getPredicateValues();
            }

            for (String name : values) {
			  String escapeName = StringEscapeUtils.escapeXml(name); 
%>
              <option value="<%= escapeName%>" <% if(selectedValues.contains(name))out.print("selected=\"true\""); %> ><%= escapeName%></option>
<%
            }
%>
           </select>
        </span>
      </div>
<%
    }
%>

    </tab-content>

    <tab-content id="change_info_tab" label="Change Request Information">

<%
    for(String predicateName : changeInfoPredicates)
    {
      PredicateBean predicate = predicateNameMap.get(predicateName);
      ArrayList<String> selectedValues = selectedPredicateValuesMap.get(predicateName);
%>
      <div class="form-row">
        <label class="widget" for="<%=predicate.getPredicateValueWidgetId()%>"><%=predicateLabelMap.get(predicateName)%>:</label>
        <span  id="<%=predicate.getPredicateValueWidgetId()%>">
          <select size="5" multiple="0" id="<%=predicate.getPredicateValueWidgetId()%>" name="<%=predicate.getPredicateValueWidgetId()%>" >
            <option value="<%=subscriptionBean.getAnyPredicateListValue() %>" <% if(selectedValues.contains(subscriptionBean.getAnyPredicateListValue()))out.print("selected=\"true\""); %> >-- ANY --</option>
<%
 			Collection<String> values;
            values = predicate.getPredicateValues();
            for (String name : values)
            {
			  String escapeName = StringEscapeUtils.escapeXml(name); 
%>
              <option value="<%= escapeName%>" <% if(selectedValues.contains(name))out.print("selected=\"true\""); %> ><%= escapeName%></option>
<%
            }
%>
           </select>
        </span>
      </div>
<%
    }
%>

    <subscription-text-predicate-table/>

    </tab-content>

<%
  if(!subscriptionBean.allOverridesSuppressed() || !subscriptionBean.isTimeframeSuppressed())
  {
%>
    <tab-content id="pref_tab" label="Preferences">

      <subscription-timeframe group-label="Timeframe" />
      <subscription-overrides group-label="Overrides" />

    </tab-content>

<%} %>

<%
  if(!subscriptionBean.isSelfSubscription())
  {
%>
    <tab-content id="assigned_tab" label="Assign">

      <subscribed-recipients group-label="Recipients" />

    </tab-content>
<%
  }
%>

</tab-group>

</group>

</subscription-panel>
